<template>
  <div
    :class="{
      BusinessCaseLane: true,
      'BusinessCaseLane--active': active,
    }"
    :style="timelineWidth()"
  >
    <div class="BusinessCaseLane__Head">
      <PSkeleton v-if="!businessCase" />
      <template v-else>
        <router-link
          class="BusinessCaseLane__Title"
          :to="{ ...ROUTES.RESOURCE, params: { uuid: businessCase.id } }"
          >{{ businessCase.name }}</router-link
        >
        <span v-if="businessCase.code">#{{ businessCase.code }}</span>
      </template>
    </div>
    <ul
      ref="laneElement"
      class="BusinessCaseLane__Tasks"
      @dragenter="dragEnter"
      @dragleave="dragLeave"
      @dragover="dragOver"
      @drop="drop"
    >
      <NowBlock />
      <WeekendBlocks />
      <TaskComponent
        v-for="task of taskMap?.values()"
        :key="task.id"
        :task="task"
        class="BusinessCaseLane__Task"
        :style="dateToPosition(task)"
        resizable
        @move:estimated-end-date="handleMoveMax"
        @end:estimated-end-date="handleEndMax"
      />
      <TaskPreview
        v-if="dropTask"
        :task="dropTask"
        class="BusinessCaseLane__Task"
        :style="dateToPosition(dropTask)"
      />
    </ul>
  </div>
</template>

<script lang="ts" setup>
import TaskComponent from './Task.vue'
import TaskPreview from './TaskPreview.vue'
import { dateToPosition, timelineWidth } from './timedPosition'
import { useI18n } from 'vue-i18n'
import { taskTree } from '@/states/weekPlanning'
import { businessCaseClient, BusinessCase, Resource, Task } from '@/api'
import { computed, ref, watchEffect } from 'vue'
import {
  draggedObject,
  handleTaskMoveAndResize,
} from '@/pages/weekPlanning/handleTaskMoveAndResize'
import { ROUTES } from '@/plugins'
import NowBlock from '@/pages/weekPlanning/NowBlock.vue'
import WeekendBlocks from '@/pages/weekPlanning/WeekendBlocks.vue'

const { t } = useI18n()
const props = defineProps<{ headId: Resource['id'] | null }>()
const name = ref<string | false>(false)
const laneElement = ref<HTMLElement>()
const taskMap = computed(() => taskTree.current.value.get(props.headId))

const {
  active,
  dragEnter,
  dragLeave,
  dragOver,
  dropTask,
  handleMoveMax,
  handleEndMax,
} = handleTaskMoveAndResize(
  laneElement,
  (draggedTask?: Task) => draggedTask?.businessCase === props.headId
)

const businessCase = ref<BusinessCase | undefined>()
watchEffect(async () => {
  if (props.headId) {
    businessCase.value = await businessCaseClient.getItem(props.headId)
  }
})

const drop = () => {
  active.value = false
  // get the draggable element
  if (draggedObject.task?.businessCase === props.headId) {
    const patch: Partial<Task> = {
      startDate: dropTask.value?.startDate,
    }
    dropTask.value = undefined
    taskTree.patch(draggedObject.task.id, patch)
  }
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use './weekPlanning' as wp;

.BusinessCaseLane {
  @include wp.Timeline;

  &__Title {
    color: inherit;
  }
}
</style>
